#include "char_lcd.h"

#include "./i2c_lcd_pcf8574.h"
#include <esp_log.h>

i2c_lcd_pcf8574_handle_t lcd;

static const char *TAG = "char_lcd";

void init_lcd() {
    ESP_LOGI(TAG, "Initializing LCD");

    lcd_init(&lcd, LCD_ADDR, CHAR_LCD_I2C_NUM);
    lcd_begin(&lcd, LCD_COLS, LCD_ROWS);

    lcd_set_backlight(&lcd, 255);

    ESP_LOGI(TAG, "LCD initialized!");
}


void lcd_clear() {
    lcd_clear(&lcd);
}

void lcd_cursor_home() {
    lcd_home(&lcd);
}

void lcd_set_cursor_pos(uint8_t col, uint8_t row) {
    lcd_set_cursor(&lcd, col, row);
}

void lcd_set_display(bool display) {
    if (display) {
        lcd_display(&lcd);
    } else {
        lcd_no_display(&lcd);
    }
}

void lcd_set_cursor_vis(bool cursor) {
    if (cursor) {
        lcd_cursor(&lcd);
    } else {
        lcd_no_cursor(&lcd);
    }
}

void lcd_set_cursor_blink(bool blink) {
    if (blink) {
        lcd_blink(&lcd);
    } else {
        lcd_no_blink(&lcd);
    }
}

void lcd_scroll_display_left() {
    lcd_scroll_display_left(&lcd);
}
void lcd_scroll_display_right() {
    lcd_scroll_display_right(&lcd);
}

void lcd_left_to_right() {
    lcd_left_to_right(&lcd);
}
void lcd_right_to_left() {
    lcd_right_to_left(&lcd);
}

void lcd_set_autoscroll(bool autoscroll) {
    if (autoscroll) {
        lcd_autoscroll(&lcd);
    } else {
        lcd_no_autoscroll(&lcd);
    }
}

void lcd_set_backlight(uint8_t brightness) {
    lcd_set_backlight(&lcd, brightness);
}

void lcd_create_char(uint8_t location, uint8_t charmap[]) {
    lcd_create_char(&lcd, location, charmap);
}

void lcd_write(uint8_t value) {
    lcd_write(&lcd, value);
}

void lcd_print(const char* str) {
    lcd_print(&lcd, str);
}

void lcd_print(uint8_t col, uint8_t row, const char* str) {
    lcd_set_cursor_pos(col, row);
    lcd_print(&lcd, str);
}